VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "InternetStatusCallback example by The trick"
   ClientHeight    =   7350
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   13545
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7350
   ScaleWidth      =   13545
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdStartApply 
      Caption         =   "Start Apply"
      Height          =   375
      Left            =   5880
      TabIndex        =   7
      Top             =   360
      Width           =   1395
   End
   Begin VB.CommandButton cmdAbort 
      Caption         =   "Abort"
      Height          =   375
      Left            =   6000
      TabIndex        =   6
      Top             =   2520
      Width           =   1395
   End
   Begin VB.Timer tmrUpdate 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   8760
      Top             =   2160
   End
   Begin VB.PictureBox lvwList 
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   1875
      Left            =   120
      ScaleHeight     =   1815
      ScaleWidth      =   5595
      TabIndex        =   5
      Top             =   840
      Width           =   5655
   End
   Begin VB.TextBox txtLog 
      BackColor       =   &H8000000F&
      Height          =   3615
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  '
      TabIndex        =   3
      Top             =   3180
      Width           =   13335
   End
   Begin VB.CommandButton cmdDownload 
      Caption         =   "Download"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4380
      TabIndex        =   2
      Top             =   360
      Width           =   1395
   End
   Begin VB.TextBox txtURL 
      Height          =   315
      Left            =   120
      TabIndex        =   1
      Text            =   "https://i.forfun.com/jujpl8yp.jpeg"
      Top             =   360
      Width           =   4215
   End
   Begin VB.Label lblLog 
      Caption         =   "Callback log:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   2940
      Width           =   1815
   End
   Begin VB.Label lblURL 
      Caption         =   "Enter URL:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5595
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' //
' // Async downloader using InternetStatusCallback
' // by The trick 2019
' //

Option Explicit

Implements ICallbackEvents

Private m_pfnPrevCallback       As Long             ' // Previous callback function


Private Sub cmdAbort_Click()
    Dim cObj    As CAsynchWIM
    
    'If lvwList.SelectedItem Is Nothing Then Exit Sub
        
    ' // Get downloader from tag
    'vbaObjSetAddref cObj,  ByVal CLng(lvwList.SelectedItem.Tag)

    m_cRequestsQueue.Abort
    
End Sub

Private Sub cmdDownload_Click()
    
    cmdDownload.Enabled = False
    

  
    
    
    m_cRequestsQueue.StartDownloading txtURL.Text
    
    
    
    'With lvwList.ListItems.Add(, "#" & ObjPtr(cObj), , , 1)
        
    '    .SubItems(3) = txtURL.Text
    '    .Tag = ObjPtr(cObj)
        
    'End With
    
End Sub

Private Sub cmdStartApply_Click()
    cmdStartApply = False
    m_cRequestsQueue.TestWIMGAPI2
End Sub

Private Sub Form_Initialize()
    modMultiThreading.Initialize
    RegisterAsyncWindowClass
End Sub

Private Sub Form_Load()
    Dim bIsInIDE    As Boolean
    
    ' // Enable grid and full row select
    'SendMessage lvwList.hwnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT Or LVS_EX_GRIDLINES, _
                                ByVal LVS_EX_FULLROWSELECT Or LVS_EX_GRIDLINES
    
    Set m_cRequestsQueue = New CAsynchWIM
    Set m_cRequestsQueue.LogWindow = txtLog
    Set m_cRequestsQueue.Callback = Me


    Debug.Assert MakeTrue(bIsInIDE)
    
    Me.Caption = Me.Caption & " TID: 0x" & Hex$(App.ThreadID)
    
    ' // Create icons
    'CreateImageListProgressIconsCollection
    
    ' // Open session
    g_hSession = InternetOpen(StrPtr(App.ProductName), INTERNET_OPEN_TYPE_PRECONFIG, 0, 0, INTERNET_FLAG_ASYNC)
    
    If g_hSession = 0 Then
        MsgBox "InternetOpen failed " & CStr(Err.LastDllError)
    Else
        cmdDownload.Enabled = True
    End If
    
    ' // Setup callback
    If bIsInIDE Then
        m_pfnPrevCallback = InternetSetStatusCallback(g_hSession, InitCurrentThreadAndCallFunctionIDEProc( _
                                                                    AddressOf InternetCallback, 20))
    Else
        m_pfnPrevCallback = InternetSetStatusCallback(g_hSession, AddressOf InternetCallbackEXE)
    End If
    
End Sub

Private Sub Form_Terminate()
    modMultiThreading.Uninitialize
    UnregisterAsyncWindowClass
End Sub

Private Sub Form_Unload( _
            ByRef Cancel As Integer)

    
    ' // Abort all
        m_cRequestsQueue.Abort
    
    Set m_cRequestsQueue = Nothing
    
    ' // Clean up
    If g_hSession Then
        InternetSetStatusCallback g_hSession, m_pfnPrevCallback
        InternetCloseHandle g_hSession
    End If
    
    g_hSession = 0
    
End Sub

'
'' // Create icons
'Private Sub CreateImageListProgressIconsCollection()
'    Dim cPicBox As PictureBox
'    Dim lState  As Long
'    Dim lX      As Long
'
'    Set cPicBox = Me.Controls.Add("VB.PictureBox", "picTemp")
'
'    cPicBox.BackColor = vbMagenta
'    cPicBox.AutoRedraw = True
'    cPicBox.ScaleMode = vbPixels
'    cPicBox.BorderStyle = 0
'
'    cPicBox.Move 0, 0, Me.ScaleX(64, vbPixels, Me.ScaleMode), Me.ScaleY(16, vbPixels, Me.ScaleMode)
'
'    ' // Draw progress bar (21 state)
'    cPicBox.Line (0, 0)-(63, 15), &H209F20, B
'
''    For lState = 0 To 100 Step 5
''
''        cPicBox.Line (1, 1)-Step(lState / 100 * 61, 6), &H80FF80, BF
''        cPicBox.Line (1, 7)-Step(lState / 100 * 61, 7), vbGreen, BF
''
''        iglIcons.ListImages.Add , , cPicBox.Image
''
''    Next
'
'    ' // Draw progress bar for unknown progress
'    For lState = 0 To 1
'
'        cPicBox.Cls
'
'        For lX = -16 To 64 Step 3
'            cPicBox.Line (lX + lState * 2, 0)-Step(16, 16), vbGreen
'        Next
'
'        cPicBox.Line (0, 0)-(63, 15), &H209F20, B
'
''        iglIcons.ListImages.Add , , cPicBox.Image
'
'    Next
'
'    ' // Draw check mark
'    cPicBox.Cls
'
'    cPicBox.DrawWidth = 3
'    cPicBox.Line (20, 10)-(25, 13), vbGreen
'    cPicBox.Line -(32, 3), vbGreen
'
''    iglIcons.ListImages.Add , , cPicBox.Image
'
'    ' // Draw cross (X)
'    cPicBox.Cls
'    cPicBox.Line (20, 3)-(30, 13), vbRed
'    cPicBox.Line (30, 3)-(20, 13), vbRed
'
''    iglIcons.ListImages.Add , , cPicBox.Image
'
'    Me.Controls.Remove "picTemp"
'
'End Sub

Private Sub ICallbackEvents_Complete( _
            ByVal cObj As CAsynchWIM)
            
            cmdDownload.Enabled = True
            cmdStartApply = True
    'Dim cItem   As ListItem
    
    'Set cItem = lvwList.ListItems("#" & ObjPtr(cObj))
    
    ' // Update icon (check mark)
    'cItem.SmallIcon = 24
    'cItem.SubItems(1) = "100%"
    
End Sub

Private Sub ICallbackEvents_Error( _
            ByVal cObj As CAsynchWIM, _
            ByVal lError As Long)
            
            cmdDownload.Enabled = True
            cmdStartApply = True
    'Dim cItem   As ListItem
    
    'Set cItem = lvwList.ListItems("#" & ObjPtr(cObj))
    
    ' // Update icon (X)
    'cItem.SmallIcon = 25

End Sub

Private Sub tmrUpdate_Timer()
    Dim cObj    As CAsynchWIM
    'Dim cItem   As ListItem
    Dim sSize   As String

    'If lvwList.ListItems.Count = 0 Then Exit Sub

    ' // Update all the items
        
        If m_cRequestsQueue.IsDownloading Then
            
            'Set cItem = lvwList.ListItems("#" & ObjPtr(cObj))
            
            If m_cRequestsQueue.Progress >= 0 Then
                'cItem.SmallIcon = Int(cObj.Progress * 20) + 1
                'cItem.SubItems(1) = Format$(cObj.Progress, "0.00%")
            Else
            
'                If cItem.SmallIcon = 0 Then
'                    cItem.SmallIcon = 22
'                ElseIf cItem.SmallIcon = 22 Then
'                    cItem.SmallIcon = 23
'                Else
'                    cItem.SmallIcon = 22
'                End If
                
                'cItem.SubItems(1) = "?"
                
            End If
            
            sSize = Space$(10)
            
            StrFormatByteSize m_cRequestsQueue.BytesCount, 0, StrPtr(sSize), Len(sSize)
            
           ' cItem.SubItems(2) = sSize
            
        End If
        

End Sub
